{$U-,R+}
PROGRAM DPB; { CPM 2 }

TYPE
  Puffer = ARRAY [1 .. 1024] OF byte;
  anystring = STRING[128];

  DPB = RECORD
    SektorenproSpur: integer;
    Blockshift: byte;
    Blockmaske: byte;
    Eintragsmaske: byte;
    AnzahlderBloecke: integer;
    Direintraege: integer;
    DirVektor: integer;
    PruefDir: integer;
    Systemspuren: integer;
  END;

  DPH = RECORD
    xlt: integer;
    ws1, ws2, ws3: integer;
    dirbuf: integer;
    DPB: integer;
    csv: integer;
    alv: integer;
  END;

VAR
  Drive, LastDrive: 0 .. 15;
  Track, Sector, Resultat: integer;
  MaxSector, MaxTrack: integer;
  LastSector, LastTrack: integer;
  Buffer: Puffer;
  Befehl: STRING[127];
  Fehler: boolean;
  i: integer;
  p: ^DPB;
  Quit: boolean;
  dphp: ^DPH;
  translatetable: integer;
  xltsec: integer;

PROCEDURE Setdma(Adresse: integer);
BEGIN
  bdos(26, Adresse);
END;

PROCEDURE Settrk(Spur: integer);
BEGIN
  bios(9, Spur);
END;

PROCEDURE Setsec(Sector: integer);
BEGIN
  inline($1A/translatetable); { ld de,(translatetable) }
  { todo alles in inline, so geht es nicht mit xlt, de wird ueberschrieben }
  xltsec := bioshl(15, Sector); { sectran }
  bios(10, xltsec); { setsec }
{  		LD BC, log. Sector
  		ld de, (translatetable)
		CALL	SECTRAN	;HL = tran(sector)
		LD	C,L                       
		LD	B,H	;BC = tran(sector)
		CALL	SETSECF	;sector selected
} 
END;

FUNCTION readsector: boolean;
BEGIN
  readsector := bios(12) > 0;
END;

FUNCTION writesector: boolean;
BEGIN
  writesector := bios(13, 1) > 0;
END;

PROCEDURE getdiskpar(VAR MaxTrack, MaxSector: integer; show: boolean);
var
  RecordsPerBlock: integer;
  BytesPerBlock: integer;
BEGIN
  writeln('Laufwerk ', chr(Drive + 65));

  dphp := ptr(bioshl(8, Drive));
  translatetable := dphp^.xlt;
  writeln('xlttable ', translatetable);
  
  p := ptr(bdoshl(31));
  WITH p^ DO
  BEGIN
    MaxSector := SektorenproSpur - 1;
    MaxTrack := round(1.0 * (1 SHL Blockshift) * succ(AnzahlderBloecke) /
      (MaxSector + 1));
    MaxTrack := MaxTrack + Systemspuren - 1;

    if show then
    begin
      writeln('DPB');
      writeln('SPT sectors per track  =', SektorenproSpur);
      writeln('BSH block shift factor =', Blockshift);
      writeln('BLM block mask         =', Blockmaske);
      writeln('EXM null mask          =', Eintragsmaske);
      writeln('DSM disk size-1        =', AnzahlderBloecke);
      writeln('DRM directory max      =', Direintraege);
      writeln('AL0/1 alloc 0+1        =', DirVektor);
      writeln('CKS check size         =', PruefDir);
      writeln('OFS track offset       =', Systemspuren);

      write('<ENTER>');
      readln;

      write('Maximale Spurnummer=', MaxTrack);
      writeln(' Maximale Sektornummer=', MaxSector);

      { STAT }
      RecordsPerBlock := (1 SHL Blockshift);
      BytesPerBlock := RecordsPerBlock * 128;
      writeln('STAT');
      writeln('Record Capacity           =',
        { round } ((1.0 * AnzahlderBloecke + 1) * RecordsPerBlock):0:0);
      writeln('Kilobyte Drive  Capacity  =',
        round((1.0 * AnzahlderBloecke + 1) * BytesPerBlock / 1024));
      writeln('Directory Entries         =', Direintraege + 1);
      writeln('Checked  Directory Entries=', PruefDir * 4);
      writeln('Records/ Extent           =', (Eintragsmaske + 1) * 128);
      writeln('Records/ Block            =', RecordsPerBlock);
      writeln('BytesPerBlock             =', BytesPerBlock);
      writeln('Sectors/ Track            =', SektorenproSpur);
      writeln('Reserved Tracks	     =', Systemspuren);
    end;

  END;
END;

PROCEDURE Delleftspace;
BEGIN
  WHILE (pos(Befehl, ' ') = 1) DO
    delete(Befehl, 1, 1)
END;

FUNCTION hex(a: byte): anystring;
CONST
  hexziffern: ARRAY [0 .. 15] OF char = '0123456789ABCDEF';
BEGIN
  hex := hexziffern[a SHR 4] + hexziffern[a AND 15];
END;

PROCEDURE Spurfestlegen;
BEGIN
  val(Befehl, Track, Resultat);
  IF length(Befehl) = 0 THEN
    writeln('=', Track)
  ELSE IF Resultat <> 0 THEN
  BEGIN
    writeln;
    writeln('Fehler');
  END
  ELSE IF Track > MaxTrack THEN
    Track := MaxTrack;
END;

PROCEDURE Sektorfestlegen;
BEGIN
  val(Befehl, Sector, Resultat);
  IF length(Befehl) = 0 THEN
    writeln('=', Sector)
  ELSE IF Resultat <> 0 THEN
  BEGIN
    writeln;
    writeln('Fehler');
  END
  ELSE IF Sector > MaxSector THEN
    Sector := MaxSector;
END;

PROCEDURE Sektorlesen;
BEGIN
  Setdma(addr(Buffer));
  Settrk(Track);
  Setsec(Sector);
  Fehler := readsector;
  IF Fehler THEN
  BEGIN
    writeln;
    writeln('Lesefehler');
  END
  ELSE
  BEGIN
    LastTrack := Track;
    LastSector := Sector;
    LastDrive := Drive;
  END;
END;

PROCEDURE Sektorschreiben;
BEGIN
  Setdma(addr(Buffer));
  Settrk(Track);
  Setsec(Sector);
  Fehler := writesector;
  IF Fehler THEN
  BEGIN
    writeln;
    writeln('Schreibfehler');
  END
  ELSE
  BEGIN
    LastTrack := Track;
    LastSector := Sector;
    LastDrive := Drive;
  END;
END;

PROCEDURE SektorNrerhoehen;
BEGIN
  Sector := succ(Sector);
  IF Sector > MaxSector THEN
  BEGIN
    Sector := 0;
    Track := succ(Track);
  END;
  IF Track > MaxTrack THEN
  BEGIN
    Track := MaxTrack;
    Sector := MaxSector;
  END;
END;

PROCEDURE SektorNrerniedrigen;
BEGIN
  Sector := pred(Sector);
  IF Sector < 0 THEN
  BEGIN
    Sector := MaxSector;
    Track := pred(Track);
  END;
  IF Track < 0 THEN
  BEGIN
    Track := 0;
    Sector := 0;
  END;
END;

PROCEDURE Sektorausgeben;
VAR
  i, j: integer;

BEGIN
  ClrScr;
  writeln('Laufwerk ', chr(LastDrive + 65), ': Spur ', LastTrack:3, ' Sektor ',
    LastSector:2);
  writeln;
  FOR i := 0 TO 7 DO
  BEGIN
    write(hex(i * 16), ' ');
    FOR j := 1 TO 16 DO
      write(' ', hex(Buffer[i * 16 + j]));
    write(' ');
    FOR j := 1 TO 16 DO
      IF ((Buffer[i * 16 + j]) AND 96) = 0 THEN
        write('.')
      ELSE
        write(chr(Buffer[i * 16 + j]));
    writeln;
  END;
END;

PROCEDURE Laufwerkselektieren;
BEGIN
  IF length(Befehl) > 0 THEN
    Drive := ord(upcase(Befehl[1])) - 65
  ELSE
    Drive := 0;
  bdos(14, Drive);
  getdiskpar(MaxTrack, MaxSector, true);
END;

PROCEDURE Help;
BEGIN
  writeln('L[A-P] - Laufwerk');
  writeln('T - Testdisk schreiben');
  writeln('F - Testdatei schreiben');
  writeln('Q - quit');
END;

procedure testdsk;
var
  s, s1, s2, s3: anystring;
  c: char;
begin
  writeln('Disk ', chr(Drive + 65), ' wird komplett ueberschrieben !!! (J/N)');
  readln(c);
  if upcase(c) <> 'J' then
    exit;

  for Track := 0 to MaxTrack do
  begin
    write(Track, ' ');
    fillchar(s, 129, chr(0));
    str(Track, s1);
    for Sector := 0 to MaxSector do
    begin
      str(Sector, s2);
      setSec(Sector); str(xltsec, s3);
      s := 'Track ' + s1 + ' log. Sektor ' + s2 +  ' phys. Sektor ' + s3;
      move(s[1], Buffer, 128);
      Sektorschreiben;
    end;
  end;
  writeln('fertig');;
end;


procedure testfile(fn: anystring; recno: integer);
var
  f:file;
  s, s1: anystring;
  rec: integer;
begin
  fillchar(buffer,139,chr(32));
  
  writeln('Schreibe Datei ',fn);
  assign(f,fn);
  rewrite(f);
  for rec:=0 to recno do begin
        str(Rec, s1);
        s := fn + ' ' + s1;
  	move(s[1], buffer[0],length(s));
  	move(f, buffer[32],48);
  	blockwrite(f, buffer, 1);
  end;
  close(f);
end;  	
	

BEGIN
  Track := 0;
  Sector := 0;
  LastTrack := Track;
  LastSector := Sector;
  Quit := false;
  Befehl := '';
  Drive := bdos(25);
  LastDrive := Drive;
  getdiskpar(MaxTrack, MaxSector, false);
  (* Sektorlesen; *)
  Help;

  REPEAT
    writeln;
    write('? ');
    REPEAT
      read(Befehl);
    UNTIL length(Befehl) > 0;
    CASE upcase(Befehl[1]) OF
      'T':
        BEGIN
          testdsk;
        END;
      'F':
        BEGIN
          testfile('DATEI1.TST',10);
          {testfile('DATEI2.TST',2300);}
        END;
      'L':
        BEGIN
          delete(Befehl, 1, 1);
          Delleftspace;
          Laufwerkselektieren;
        END;
      'Q':
        Quit := true;
    END;
  UNTIL Quit
END.
